/***************************************************************************
 *   Copyright (C) 2005 by JSRiera				           *
 *   http://www.xtec.cat/dnee/udc/english/main.html		           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#include "CGame.h"

void CGame::Init (char *filename, int fs, int fv, int fh)
{

	if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 )
	{
		printf("Unable to init SDL: %s\n", SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);

	if (fs)
		screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_HWPALETTE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
	else
		screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_HWPALETTE|SDL_DOUBLEBUF);

	if ( screen == NULL )
	{
		printf("Unable to set 640x480 video: %s\n", SDL_GetError());
		exit(1);
	}

	if (Mix_OpenAudio(44100, AUDIO_S16SYS, 1, 2048) <0)
	{
		printf("Unable to set Audio.Error %s\n", SDL_GetError());
		exit(2);
	}

	SDL_WM_SetCaption("WebColorToy", "WebColorToy");

	SDL_ShowCursor (SDL_DISABLE);

	sprintf(fgame, "%s/game", filename);
	printf("File Game: %s\n", fgame);

	path = filename;
	// Carreguem tot el necessari de bon principi

	int iniwebcam = cip.InitializeWebcam (0, fv, fh);
	if (iniwebcam < 0 ) { printf("No es troba la webcam\n"); exit (-1); }
	
	recta.x = 300;
	recta.y = 0;
	recta.w = 40;
	recta.h = 480;

	char buf[120];

	sprintf(buf, "%s/basics/font/bigyellowfont.bmp", path);
	yfont = SFont_InitFont(IMG_Load(buf));
	sprintf(buf, "%s/basics/font/yellowfont.bmp", path);
	font = SFont_InitFont(IMG_Load(buf));
	sprintf(buf, "%s/basics/font/whitefont.bmp", path);
	wfont = SFont_InitFont(IMG_Load(buf));
	sprintf(buf, "%s/basics/vida.bmp", path);
	imgvida = ImageLoad(buf);

	sprintf(buf, "%s/basics/boto", path);
	boto_nivell.init(screen, buf);
	sprintf(buf, "%s/basics/boto", path);
	boto_comencar.init(screen, buf);

	sprintf(buf, "%s/basics/cursor", path);
	cursor.init(screen, buf);

	printf("Basics Loaded\n");


	LoadParameters ();
	printf("Parameters Loaded\n");

	
	done = 1;
	vida = 3;

	estat = INICI;
	ResetTemps ();

	num_morts = 0;
	stage = 0;
	fc = 0;
	fn = 0;
	bn = 0;
	bucle = 0;

	mus_menu.PlayMusic (-1);
	girarv = 0;
	girarh = 0;

}

void CGame::ResetTemps ()
{
	sdlgt=0;
	dt=0;              
	td=0;
	td2=0;     
	blast=0;
}

void CGame::LoadStageParameters (int stage)
{
	FILE *fp;
	char buffer[80];
	char buf [80];
	char cami [80];

	if((fp=fopen(fgame, "r")) == NULL)
	//if((fp=fopen("omple.txt", "r")) == NULL)
	{
		printf("ERROR opening file %s\n\n", fgame);
	}

	fseek(fp, 0, SEEK_SET);

	// Carrega parametres
	// Saltem 3 primeres linies
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  

	// obtenim num nivells
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%i", &levels);  
	
	printf("nivells:%d\n", levels);

	for (int i=0; i<stage; i++)
	{
		// temps partida
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &minutes[i]);
		//sscanf(buffer, "%i", &time_min);
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &seconds[i]);
		//sscanf(buffer, "%i", &time_sec);
		printf("Time: %i::%i\n", minutes[i], seconds[i]);
		//printf("Time: %i::%i\n", time_min, time_sec);

		// msica joc
		fgets(buffer, 80, fp);
		sscanf(buffer, "%s", buf);
		sprintf(cami, "%s/%s", path, buf);
		int err = mus_joc[i].LoadMusic(cami);
		if (!err) { printf("Error loading music\n"); exit (0);}
		printf("Music Game: %s\n", cami);

		// Count: quants hem de matar per finalitzar nivell
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &count[i]);
		printf("Count: %i\n", count[i]);

		// Show: quants en mostrem
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &obj_pantalla[i]);
		printf("Show elem: %i\n", obj_pantalla[i]);

		// Temps: cada quant els mostrem
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &time[i]);
		printf("Creation time: %i\n", time[i]);

		
		// Number of elements
		fgets(buffer, 80, fp);
		sscanf(buffer, "%i", &elem[i]);
		printf("Number of elems: %i\n", elem[i]);
		for (int j=0;j<elem[i];j++)
		{
			char buf_pic[80];
			char buf_sound[80];
			int type, vel, act, px, py;
			
			// Carreguem sprite
			fgets(buffer, 80, fp);
			sscanf(buffer, "%s", buf); 
			sprintf(buf_pic, "%s/%s", path, buf);
			printf("Sprite: %s\n", buf_pic);

			// Carreguem so
			fgets(buffer, 80, fp);
			sscanf(buffer, "%s", buf); 
			sprintf(buf_sound, "%s/%s", path, buf);
			printf("Sound: %s\n", buf_sound);

			// Quin tipus s
			fgets(buffer, 80, fp);
			sscanf(buffer, "%i", &type); 
			printf("Type: %i\n", type);

			// Posici inicial
			fgets(buffer, 80, fp);
			sscanf(buffer, "%i", &px); 
			fgets(buffer, 80, fp);
			sscanf(buffer, "%i", &py); 
			printf("Position: %i::%i\n", px, py);

			// Velocitat. (el sentit ja va inclos)
			fgets(buffer, 80, fp);
			sscanf(buffer, "%i", &vel); 
			printf("Speed: %i\n", vel);
			
			// Acci a realitzar
			fgets(buffer, 80, fp);
			sscanf(buffer, "%i", &act); 
			printf("Action: %i\n", act);

			//Inicialitzem objecte
			if (type == 0) 
				object[i][j] = new CObject1 (screen, buf_pic, vel, buf_sound, act, px, py);
			else if (type == 1)
				object[i][j] = new CObject2 (screen, buf_pic, vel, buf_sound, act, px, py);
			else
				object[i][j] = new CObject3 (screen, buf_pic, vel, buf_sound, act, px, py);

		}
	}

	fclose(fp);	
}

bool CGame::LoadParameters ()
{
	FILE *fp;
	char buffer[80];
	char buf [80];
	char cami [80];

	if((fp=fopen(fgame, "r")) == NULL)
	//if((fp=fopen("omple.txt", "r")) == NULL)
	{
		printf("ERROR opening file %s\n\n", fgame);
	}

	fseek(fp, 0, SEEK_SET);

	// Carrega parametres

	// nom creador activitat
	fgets(buffer, 80, fp);  
	sscanf(buffer, "%s", nom);  

	// Direcci pantalla presentaci
	fgets(buffer, 80, fp);
	sscanf(buffer, "%s", buf);
	sprintf(cami, "%s/%s", path, buf);
	ini = ImageLoad(cami);
	printf("Image Game: %s\n", cami);

	// msica inici i men
	fgets(buffer, 80, fp);
	sscanf(buffer, "%s", buf);
	sprintf(cami, "%s/%s", path, buf);
	mus_menu.LoadMusic(cami);
	printf("Music Menu: %s\n", cami);

	// Number of levels
	fgets(buffer, 80, fp);
	sscanf(buffer, "%i", &levels);
	printf("Levels: %i\n", levels);

	fclose (fp);

	sleep(1);

	LoadStageParameters (1);

	return true;
}


SDL_Surface* CGame::ImageLoad(char *file)
{
	SDL_Surface *temp1, *temp2;
	temp1 = IMG_Load(file);
	temp2 = SDL_DisplayFormat(temp1);
	SDL_FreeSurface(temp1);
	return temp2;
}

void CGame::ConvertBGRToRGB(IplImage * image) {
	
	char color;
		
	for (int i=0; i < image->width*image->height*3; i+=3) {
			
		color      = image->imageData[i];
		image->imageData[i]   = image->imageData[i+2];
		image->imageData[i+2] = color;
	}					
}


SDL_Surface* CGame::FrameLoad (IplImage *image)
{
	SDL_Surface *temp1;
	SDL_Surface *temp2;
    Uint32 rmask, gmask, bmask, amask;

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

	ConvertBGRToRGB(image);

	temp1 = SDL_CreateRGBSurfaceFrom(image->imageData, 640, 480, 24, 1920, 
                                      rmask, gmask, bmask, amask);

	
	temp2 = SDL_DisplayFormat(temp1);
	SDL_FreeSurface(temp1);
	return temp2;
}

void CGame::DrawIMG(SDL_Surface *img, int x, int y)
{
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	SDL_BlitSurface(img, NULL, screen, &dest);
}

void CGame::DrawIMGA(SDL_Surface *img, int x, int y)
{
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	SDL_SetAlpha(img, SDL_SRCALPHA, 180);
	SDL_BlitSurface(img, NULL, screen, &dest);
}

// Blit a portion of an image on the screen surface
void CGame::DrawIMG(SDL_Surface *img, int x, int y,
                        int w, int h, int x2, int y2)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_Rect dest2;
  dest2.x = x2;
  dest2.y = y2;
  dest2.w = w;
  dest2.h = h;
  SDL_BlitSurface(img, &dest2, screen, &dest);
}

void CGame::ProcessarEvent()
{
	SDL_Event event;
	while ( SDL_PollEvent(&event) )
	{
		if ( event.type == SDL_QUIT )  {  done = 0;  }

		if ( event.type == SDL_KEYDOWN ) {
			if ( event.key.keysym.sym == SDLK_RETURN ) estat = OPCIONS;
			if ( event.key.keysym.sym == SDLK_ESCAPE ) {
				mus_joc[stage].StopMusic ();
				mus_menu.PlayMusic(-1);

				if (estat == INICI) done = 0;
				else estat = INICI;
			}
			// change to black&white mode
			if (event.key.keysym.sym == 'b' )
			{
				if (bn == 1) bn = 0;
				else bn = 1;
			}
		}
		int px, py;
		SDL_GetMouseState(&px, &py);
		// actualize cursor position
		cursor.xset (px); cursor.yset(py);

	
		if (event.button.button == SDL_BUTTON_LEFT)
		{
			x = px; y = py;
			if ((estat == OPCIONS)
				&& (x < 320) && (y < 400)) 
			{	
				fc = 0; estat = JUGANT; 
				//InitObjects();
				vida = 3;
				num_morts = 0;
				obj = 0;
				stage = 0;
				time_min = minutes[stage];
				time_sec = seconds[stage];
				mus_menu.StopMusic ();
				sleep (1);
				mus_joc[stage].PlayMusic(-1);
			}
			if ((estat == OPCIONS)
				&& (x > 320) && (y < 400)) 
			{
				//Finalitzar ();//estat = INICI;
				//exit (1);
				done = 0;
			}
		}
	}
}

void CGame::DibuixaVides(int vides)
{
	if (vida == 3) {
		DrawIMG(imgvida, 490, 30);
		DrawIMG(imgvida, 540, 30);
		DrawIMG(imgvida, 590, 30);
	} else if (vida == 2) {
		DrawIMG(imgvida, 540, 30);
		DrawIMG(imgvida, 590, 30);
	} else if (vida == 1) {
		DrawIMG(imgvida, 590, 30);
	}
}

void CGame::DrawScene ()
{
	DrawIMG(fondo, 0, 0);
	//DrawIMGA(back, 0, 0);
	sprintf(buffer, "%d", num_morts);
	SFont_WriteSubCenter (screen, yfont, 0, 200, 0, buffer);
	if (time_sec < 10)
		sprintf(buffer, "%d:%d%d", time_min, 0, time_sec);
	else sprintf(buffer, "%d:%d", time_min, time_sec);
	//printf("Temps partida: %i::%i\n", time_min, time_sec);
	SFont_WriteCenter (screen, yfont, 0, buffer);
	DibuixaVides(vida);
}

void CGame::Clock() {
    
	static int lasttime  = 0;       
    int currenttime = SDL_GetTicks();

    if( currenttime - lasttime > 1000 ) {        
        lasttime = currenttime;

		if (time_min >=0 && time_sec >= 0)
		{
			if (--time_sec < 0) {
				time_sec = 59;

				if (--time_min < 0) {
					time_min = 0;
					time_sec = 0;
				}
			}
		}
	}
}

void CGame::Joc()
{

	cip.CaptureFrame (640, 480);
	cip.CalculateMovement ();

	if (bn == 0) 
	{
		IplImage *data = cip.GetPicture (IMAGE, 0);
		fondo = FrameLoad(data);
	}
	//if (bn == 1)
	else
	{
		IplImage *bg = cip.GetPicture (MOVE_BKG, 0);
		fondo = FrameLoad(bg);
	}

	//
	// state machine
	//

	if (estat == JUGANT) {
		//SDL_FillRect(screen, &recta, SDL_MapRGBA(screen->format, 0, 0, 0, 0));
		//SDL_FillRect(screen, &recta, SDL_MapRGBA(screen->format, 128, 128, 128, 128));


		Clock(); // contem el temps de la partida
		DrawScene();
		
		// only one object is displayed on screen
		if (obj_pantalla[stage] == 1)
		{
			if (object[stage][obj]->IsAlive ())
			{
				object[stage][obj]->Draw ();
				object[stage][obj]->Move ();
				
				//SDL_Rect rect = {object[obj]->GetX(), object[obj]->GetY(), object[obj]->GetW(), object[obj]->GetH()};
				//SDL_FillRect (screen, &rect, 0xFFFF00);

				//if ((imgproc.NumPixelsNoZero(object[stage][obj]->GetX(), object[stage][obj]->GetY(), object[stage][obj]->GetW(), object[stage][obj]->GetH()) > 50)
				//	|| (object[stage][obj]->Tocat (x,y)))
				if ((cip.GetPixelsNoZero(object[stage][obj]->GetX(), object[stage][obj]->GetY(), object[stage][obj]->GetW(), object[stage][obj]->GetH()) > 0)
					|| (object[stage][obj]->Tocat (x,y)))
				{
					x=0;y=0;
					object[stage][obj]->Kill();
					if (object[stage][obj]->GetAction() == 0)
						num_morts++;
					else if (object[stage][obj]->GetAction() == 1)
						vida--;
					else if (object[stage][obj]->GetAction() == 2)
						if (girarv == 0) girarv = 1;
						else girarv = 0;
					else if (object[stage][obj]->GetAction() == 3)
						if (girarh == 0) girarh = 1;
						else girarh = 0;						
				}
				object[stage][obj]->AutoKill (); // ens matem si estem fora la pantalla

			} 
			else 
			{
				obj = rand()%elem[stage];
				// posar temps que esperem per a tornar a crear objecte
				if (TempsTranscorregut(time[stage])) object[stage][obj]->Create ();
			}
		}
		// more than one object are displayed on screen
		else
		{
		// objectes que volem que es mostrin per pantalla obj_pantalla	
		for (int i=0; i<elem[stage]; i++)
		{
			if (object[stage][i]->IsAlive ())
			{
				object[stage][i]->Draw ();
				object[stage][i]->Move ();
				//if ((imgproc.NumPixelsNoZero(object[stage][i]->GetX(), object[stage][i]->GetY(), object[stage][i]->GetW(), object[stage][i]->GetH()) > 50)
				//	|| (object[stage][i]->Tocat (x,y)))
				if ((cip.GetPixelsNoZero(object[stage][i]->GetX(), object[stage][i]->GetY(), object[stage][i]->GetW(), object[stage][i]->GetH()) > 0)
					|| (object[stage][i]->Tocat (x,y)))
				{
					x=0;y=0;
					object[stage][i]->Kill();
					if (object[stage][i]->GetAction() == 0)
						num_morts++;
					else if (object[stage][i]->GetAction() == 1)
						vida--;
					else if (object[stage][i]->GetAction() == 2)
						if (girarv == 0) girarv = 1;
						else girarv = 0;
					else if (object[stage][i]->GetAction() == 3)
						if (girarh == 0) girarh = 1;
						else girarh = 0;						
				}
				object[stage][i]->AutoKill (); // ens matem si estem fora la pantalla

			} 
			else 
			{
				// posar temps que esperem per a tornar a crear objecte
				if (TempsTranscorregut(time[stage])) object[stage][i]->Create ();
			}
		}
		}


		//printf("time: %d:%d\n", time_min, time_sec);
		//printf("morts: %d\n", num_morts);
		//printf("vida: %d\n", vida);
		// verifiquem condicions per acabar nivell
		// o s'ha acabat el temps, o ja hem contat prous elements, o s'han acabat les vides
		if (((time_min == 0) && (time_sec == 0)) || (num_morts > count[stage]) || (vida <= 0))
		{
			mus_joc[stage].StopMusic ();
			mus_menu.PlayMusic (-1);
			//estat = CREDITS;
			estat = TRANSICIO;
			j = 480;
			vida = 3;
			time_sec = 2;
			num_morts = 0;
			//stage = 0;
		}
    }

	else if (estat == INICI) {
		DrawIMG(ini, 0, 0);
		if (TempsTranscorregut (5000)) estat = OPCIONS; 
		num_morts = 0;
		//object[0]->Create();
		stage = 0;
		vida = 3;
		//count = 50;  Variable a escollir per l'usuari
	}
	else if (estat == TRANSICIO) {
		// parem tota la musica i podriem posar algun altre efecte
		DrawIMG(fondo, 0, 0);
		Clock ();
		if (time_sec == 0)
		{

			printf("Levels: %i\n", levels);
			if (stage == levels - 1)
			{
				estat = CREDITS;
				stage = 0; num_morts = 0; vida = 3; obj = 0;
			}
			else
			{
				char lev[40];
				stage++;
				sprintf(lev, "Nivell %d Superat!", stage);
				SFont_WriteCenter(screen, font, 200, lev);
				SDL_Flip(screen);
				sleep (1);
				//stage++;
				//mus_joc.StopMusic ();
				//millor noms alliberar-los al final del joc
				//FreeObjects ();
				// llegir nous parametres del joc
				estat = JUGANT; num_morts = 0; vida = 3; obj = 0;
				LoadStageParameters (stage + 1);
				time_min = minutes[stage];
				time_sec = seconds[stage];
			}
		}
	}

	else if (estat == CREDITS) {
		DrawIMG(fondo, 0, 0);
		SFont_WriteCenter(screen, font, j-=2, "Activitat creada per: ");
		sprintf(buffer, "%s", nom);
		SFont_WriteCenter(screen, wfont, j+20, buffer);
		if (j<0) {
			estat = OPCIONS;
			mus_joc[stage].StopMusic ();
			mus_menu.PlayMusic(-1);
		}

	}

	else if (estat == OPCIONS) {
		
		DrawIMG(fondo, 0, 0);

		SFont_Write(screen, font, 40, 180, "INICIA");
		boto_nivell.set(50, 50);
		boto_nivell.stopAnim();
		boto_nivell.setFrame(fn);
		boto_nivell.draw ();
		// boto groc: comenar joc
		//SDL_Rect rect1 = {50, 50, boto_nivell.getw(), boto_nivell.geth()};
		//SDL_FillRect (screen, &rect1, 0xFFFF00);
		//if (imgproc.NumPixelsNoZero(50, 50, boto_nivell.getw(), boto_nivell.geth()) > 20) 
		if (cip.GetPixelsNoZero(50, 50, boto_nivell.getw(), boto_nivell.geth()) > 0) 
		{ 
			fn++;
			if (fn == 13) { 
				fn = 0; estat = JUGANT; 
				//InitObjects ();
				vida = 3;
				obj = 0;
				num_morts = 0;
				stage = 0;
				time_min = minutes[stage];
				time_sec = seconds[stage];
				mus_menu.StopMusic ();
				mus_joc[stage].PlayMusic(-1);
			}
		} else fn = 0;
		boto_comencar.set(400, 50);
		boto_comencar.stopAnim ();
		boto_comencar.setFrame(fc);
		boto_comencar.draw ();
		// boto vermell => sortir
		//SDL_Rect rect2 = {400, 50, boto_comencar.getw(), boto_comencar.geth()};
		//SDL_FillRect (screen, &rect2, 0xFF0000);
		//if (imgproc.NumPixelsNoZero(400, 50, boto_comencar.getw(), boto_comencar.geth()) > 20) 
		if (cip.GetPixelsNoZero(400, 50, boto_comencar.getw(), boto_comencar.geth()) > 0) 
		{ 
			fc++;
			//if (fc == 13) Finalitzar (); estat = INICI;
			//exit (1);
			if (fc == 13) done = 0;
		} else fc = 0;
		SFont_Write(screen, font, 440, 180, "SURT");
	}

	// draw cursor. necessary for full screen mode
	cursor.draw ();
	
	SDL_Flip(screen);
	if (fondo) SDL_FreeSurface(fondo);

}

int CGame::Finalitzar ()
{
	return done;
}

void CGame::Espera (int temps)
{
	SDL_Delay(temps);
}

void CGame::FreeJoc()
{
	SFont_FreeFont(yfont);
	SDL_FreeSurface(screen);
}

void CGame::AfegirMosquit(int num, int temps)
{
	if (TempsTranscorregut(temps)) {
		for (int i=0; i<elem[stage]; i++) {
			object[stage][i]->Create ();
		}
	}
}

int CGame::TempsTranscorregut (int temps)
{
    td2=SDL_GetTicks();
	dt=((float)(td2-td))*0.1;
    td=td2;
	sdlgt+=dt*10;
	if (sdlgt-blast>temps)
	{
		blast=(Uint32)sdlgt;
		return 1;
	} else return 0;
}

void CGame::FreeObjects ()
{
	//Mix_FreeMusic(music);
	//Mix_FreeChunk(effect);

	for (int i=0; i<elem[stage];i++)
		for (int j=0; j<levels; j++)	
			delete object[i][j];
}

CGame::~CGame()
{
	for (int i=0; i<elem[stage];i++)
		for (int j=0; j<levels; j++)	
			delete object[i][j];
}

