/***************************************************************************
 *   Copyright (C) 2005 by JSRiera							               *
 *   http://www.xtec.cat/dnee/udc/english/main.html					       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#ifndef CGAME_H
#define CGAME_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <SDL.h>
#include "SDL_image.h"
#include "SFont.h"
#include "CObject.h"
#include "CSprite.h"
#include "CImgProc.h"
//#include "CStrings.h"
#include "CSound.h"


#define MOSQUITS 8
#define MAX_OBJECTS	10
#define MAX_LEVELS	5

enum EstatJoc { INICI, OPCIONS, JUGANT, TRANSICIO, CREDITS };

class CGame 
{
public:
	void Init (char * file, int fs, int fv, int fh);
	void Joc();
	void ProcessarEvent();
	void FreeJoc();
	int  Finalitzar();
	void Espera(int temps);
	~CGame();

protected:

	SDL_Surface* ImageLoad(char *file);
	SDL_Surface* FrameLoad(IplImage *image);
	void ConvertBGRToRGB(IplImage *image);
	void DrawIMG(SDL_Surface *img, int x, int y);
	void DrawIMGA(SDL_Surface *img, int x, int y);
	void DrawIMG(SDL_Surface *img, int x, int y, int w, int h, int x2, int y2);
	void DibuixaVides(int vides);
	void AfegirMosquit(int num, int temps);
	int  TempsTranscorregut(int temps);
	void DrawScene ();
	void Clock();
	void FreeObjects ();
	void ResetTemps ();
	bool LoadParameters ();
	void LoadStageParameters (int stage);

private:
	SDL_Surface *screen;
	SDL_Surface *ini;
	SDL_Surface *back;
	SDL_Surface *fondo;
	SDL_Surface *imgvida;
	SDL_Rect recta;
	CObject *object[MAX_LEVELS][MAX_OBJECTS];
	SFont_Font *yfont;
	SFont_Font *font;
	SFont_Font *wfont;
	CSprite boto_nivell;
	CSprite boto_comencar;
	CSprite cursor;
	CImgProc cip;
	char fgame[40];
	CSound mus_menu;
	CSound mus_joc[MAX_LEVELS];
	int done;
	int vida;
	int bn;
	EstatJoc estat;
	float sdlgt;
	float dt;              
	int td,td2;     
	Uint32 blast;
	int x, y;		// posicio mouse
	int num_morts;
	int stage;  // nivell que estem
	char buffer[80];
	char *path; //adrea d'on penja tot el joc
	int j;
	int fc, fn;
	int bucle;
	int minutes[MAX_LEVELS], seconds[MAX_LEVELS], time[MAX_LEVELS];
	int time_min, time_sec;
	char nom[80];
	int elem[MAX_LEVELS];	// objectes que hem creat
	int obj; // indica quin objecte mostrar, quan nomes en mostrem 1
	int obj_pantalla[MAX_LEVELS];	// objectes que mostrarem per pantalla
	int girarv, girarh;
	int count[MAX_LEVELS];
	int levels, elements;

};

#endif
