/***************************************************************************
 *   Copyright (C) 2005 by JSRiera							               *
 *   http://www.xtec.cat/dnee/udc/english/main.html					       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#include "CObject.h"
/*
CObject::CObject(SDL_Surface *screen)
{
//	dibuixe.init (screen, "data\\mosquite");
//	dibuixd.init (screen, "data\\mosquitd");
}
*/
void CObject::Init(SDL_Surface *screen, char * pixmap)
{
	picture.init (screen, pixmap);
}

/*
void CObject::Cau()
{
	if (sentit == ESQUERRA) {
		dibuixe.xadd(4);
		dibuixe.yadd(32);
		if (dibuixe.gety() > 480) Mata();
	} else {
		dibuixd.xadd(-4);
		dibuixd.yadd(32);
		if (dibuixd.gety() > 480) Mata();
	}
}
*/

int CObject::DetectCollide(CSprite *sprite)
{
	int centre_x1, centre_x2, centre_y1, centre_y2;
	int radi_x1, radi_x2, radi_y1, radi_y2;
	int delta_x, delta_y;
	int suma_x, suma_y;

	centre_x1 = picture.getx() + picture.getw()/2;
	centre_x2 = sprite->getx() + sprite->getw()/2;
	centre_y1 = picture.gety() + picture.geth()/2;
	centre_y2 = sprite->gety() + sprite->geth()/2;

	radi_x1 = abs(centre_x1 - picture.getx());
	radi_x2 = abs(centre_x2 - sprite->getx());
	radi_y1 = abs(centre_y1 - picture.gety());
	radi_y2 = abs(centre_y2 - sprite->gety());

	delta_x = abs(centre_x1 - centre_x2);
	delta_y = abs(centre_y1 - centre_y2);

	suma_x = radi_x1 + radi_x2;
	suma_y = radi_y1 + radi_y2;

	if( delta_x <= suma_x && delta_y <= suma_y )
		return 1;
	else return 0;
}


int CObject::DetectCollide (int x, int y, int w, int h)
{
	int centre_x1, centre_x2, centre_y1, centre_y2;
	int radi_x1, radi_x2, radi_y1, radi_y2;
	int delta_x, delta_y;
	int suma_x, suma_y;

	centre_x1 = picture.getx() + picture.getw()/2;
	centre_x2 = x + w/2;
	centre_y1 = picture.gety() + picture.geth()/2;
	centre_y2 = y + h/2;

	radi_x1 = abs(centre_x1 - picture.getx());
	radi_x2 = abs(centre_x2 - x);
	radi_y1 = abs(centre_y1 - picture.gety());
	radi_y2 = abs(centre_y2 - y);

	delta_x = abs(centre_x1 - centre_x2);
	delta_y = abs(centre_y1 - centre_y2);

	suma_x = radi_x1 + radi_x2;
	suma_y = radi_y1 + radi_y2;

	if( delta_x <= suma_x && delta_y <= suma_y )
		return 1;
	else return 0;
}

void CObject::Draw ()
{
	picture.draw ();
}

void CObject::Kill()
{
	state = DEAD;
	effect.PlayEffect (0);
}

int  CObject::IsAlive ()
{
	if (state == ALIVE) return 1;
	else return 0;
}

void CObject::SetAction (int i)
{
	action = i;
}

int CObject::GetAction ()
{
	return action;
}

void CObject::DoLive ()
{
	state = ALIVE;
}

int  CObject::GetVelocity ()
{
	return step;
}

void CObject::AutoKill ()
{
	if ((picture.getx() + picture.getw() < 0) || (picture.getx() > 640)
		|| (picture.gety() + picture.geth() < 0) || (picture.gety() > 480)) {
		state = DEAD;
	}
}

int CObject::Tocat(int x, int y)
{
	return picture.esDins (x, y);
}

void CObject::AddX ()
{
	picture.xadd(step);
}

void CObject::AddY ()
{
	picture.yadd(step);
}

void CObject::SetVelocity (int inc)
{
	step = inc;
}

void CObject::SetPos (int x, int y)
{
	picture.set(x, y);
}

void CObject::SetEffectPath(char *path)
{
	effect.LoadEffect (path);
}

void CObject::SetCreaPos (int x, int y)
{
	crea_x = x;
	crea_y = y;
}

int CObject::GetCreaPosX ()
{
	return crea_x;
}

int CObject::GetCreaPosY ()
{
	return crea_y;
}

CObject1::CObject1(SDL_Surface *screen, char * pixmap, int vel, 
				   char *peff, int act, int px, int py)
{
	Init(screen, pixmap);
	SetVelocity (0);
	SetEffectPath(peff);
	SetAction (act);
	SetPos (px, py);
	return;
}

void CObject1::Move ()
{
}

void CObject1::Create ()
{
	DoLive ();
}

CObject2::CObject2(SDL_Surface *screen, char * pixmap, int vel, 
				   char *peff, int act, int px, int py)
{
	Init(screen, pixmap);
	SetVelocity(vel);
	SetEffectPath(peff);
	SetAction (act);
	SetCreaPos (px, py);
	//pos_x = px; pos_y = py;
	return;
}

// Ens movem d'esquerra a dreta o d'esquerra a dreta
void CObject2::Move ()
{
	AddX();
}

void CObject2::Create()
{
	int vel;
	int y;
	DoLive();
	vel = GetVelocity ();
	y = GetCreaPosY ();
	if (y == 0)
	{
		if (vel > 0) SetPos(0, rand()%400);
		else SetPos(640, rand()%400);
	}
	else
	{
		if (vel > 0) SetPos(0, y);
		else SetPos(640, y);
	}
}

CObject3::CObject3(SDL_Surface *screen, char * pixmap, int vel, 
				   char *peff, int act, int px, int py)
{
	Init(screen, pixmap);
	SetVelocity(vel);
	SetEffectPath (peff);
	SetAction (act);
	SetCreaPos (px, py);
	//pos_x = px; pos_y = py;
	return;
}

// Movem d'amunt a avall o d'avall a amunt
void CObject3::Move ()
{
	AddY();
}

void CObject3::Create()
{
	int vel;
	int x;
	DoLive();
	vel = GetVelocity ();
	x = GetCreaPosX ();
	if (x == 0) 
	{
		if (vel > 0) SetPos(rand()%580, 0);
		else SetPos(rand()%580, 480);
	}
	else
	{
		if (vel > 0) SetPos(x, 0);
		else SetPos(x, 480);
	}
}
