/***************************************************************************
 *   Copyright (C) 2005 by JSRiera							               *
 *   http://www.xtec.cat/dnee/udc/english/main.html 				       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#ifndef COBJECT_H
#define COBJECT_H

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "CSprite.h"
#include "CSound.h"

enum State { DEAD, ALIVE };

class CObject
{
public:
	CObject(){}; 
	~CObject() {};
	void Init(SDL_Surface *screen, char * pixmap);
	virtual void Move() = 0;
	virtual void Create () = 0;
	//void Mou();
	int  DetectCollide (CSprite *sprite);
	int  DetectCollide (int x, int y, int w, int h);
	void Draw();
	void Kill();
	void AutoKill();
	int  IsAlive ();
	int  Tocat(int x, int y);
	int  GetX () { return picture.getx(); }
	int  GetY () { return picture.gety(); }
	int  GetW () { return picture.getw(); }
	int  GetH () { return picture.geth(); }
	int  GetAction ();

protected:
	void AddX ();
	void AddY ();
	void SetVelocity (int inc);
	void DoLive ();
	int  GetVelocity ();
	void SetPos (int x, int y);
	void SetEffectPath (char *path);
	void SetAction (int i);
	void SetCreaPos (int x, int y);
	int  GetCreaPosX ();
	int  GetCreaPosY ();

private:
	CSprite picture;	// dibuix
	int step;			// velocitat moviment
	State  state;		// estat de l'objecte: viu, mort
	CSound effect;
	int action;
	int crea_x, crea_y;
};

// Objecte quiet
class CObject1: public CObject
{
public:
	CObject1(SDL_Surface *screen, char *pixmap, int vel, char *peff,
											int act, int px, int py); 
	~CObject1() {};
	void Move();
	void Create ();
};

// Movem esquerra - dreta
class CObject2: public CObject
{
public:
	CObject2(SDL_Surface *screen, char *pixmap, int vel, char *peff, 
										int act, int px, int py); 
	~CObject2() {};
	void Move();
	void Create ();
};

// Movem amunt - avall
class CObject3: public CObject
{
public:
	CObject3(SDL_Surface *screen, char *pixmap, int vel, char *peff,
											int act, int px, int py);
	~CObject3() {};
	void Move();
	void Create ();
};

#endif
